#pragma once

#ifndef WIN32
  #include <unistd.h>
#endif

#include <string>
#include <vector>

namespace fcf {

  #ifdef WIN32
  typedef DWORD pid_t;
  #else
  typedef ::pid_t pid_t;
  #endif

  pid_t         create_process_cstr(const char* a_name,
                                    std::vector<std::string> a_argv,
                                    std::vector<std::pair<std::string, std::string> > a_envv,
                                    const char* a_user,
                                    const char* a_password);

  template<typename TyName, typename TyUser, typename TyPassword>
  inline pid_t  create_process(TyName a_name,
                               std::vector<std::string> a_argv,
                               std::vector<std::pair<std::string, std::string> > a_envv,
                               TyUser a_user,
                               TyPassword a_password) {
    return create_process_cstr(&a_name[0], a_argv, a_envv, &a_user[0], &a_password[0]);
  }

  void          close_process(pid_t a_pid);

  size_t        get_process_memory_size(int a_pid);

  bool          check_pid(pid_t a_pid);

}